unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, JvExStdCtrls, JvCombobox, JvDriveCtrls, JvListBox, FileCtrl,
  ComCtrls, JvExComCtrls, JvComCtrls, JvCheckTreeView, CheckLst, JvExCheckLst,
  JvCheckListBox, JvPlaylist, JvFullColorSpaces, JvFullColorCtrls, JvTextListBox,
  ExtCtrls, Mask, JvExMask, JvToolEdit;

type
  TFormMain = class(TForm)
    JvDriveCombo1: TJvDriveCombo;
    JvFileListBox1: TJvFileListBox;
    JvDirectoryListBox1: TJvDirectoryListBox;
    JvDriveCombo2: TJvDriveCombo;
    JvFileListBox2: TJvFileListBox;
    JvDirectoryListBox2: TJvDirectoryListBox;
    procedure JvFileListBox1DblClick(Sender: TObject);
    procedure JvFileListBox2DblClick(Sender: TObject);
    procedure JvFileListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure JvFileListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure JvFileListBox2DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure JvFileListBox2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);

   private
    function RemoveSpace(Filename: string): string;

  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}



function TFormMain.RemoveSpace(Filename: string): string;
 var ld: integer;
     c: char;
begin
 ld:=LastDelimiter('\', Filename);

 if (ld>0) and (ld<Length(Filename)) then
 begin
  c:=Filename[ld+1];

  if c=' ' then Delete(Filename, ld+1, 1);
 end;

 Result:=filename;
end;



procedure TFormMain.JvFileListBox1DblClick(Sender: TObject);
 var filename: string;
begin
// Un-comment next line to see the selected filename.
 Application.MessageBox(PAnsiChar(JvFileListBox1.FileName), 'Filename');

 // Remove space after directory name.
 filename:=RemoveSpace(JvFileListBox1.FileName);

// Un-comment next line to see the selected filename.
// Application.MessageBox(PAnsiChar(filename), 'Filename');

 if DirectoryExists(filename) then
 begin
  JvDirectoryListBox1.Directory:=filename;
  JvFileListBox1.Update;
  JvDirectoryListBox1.Update;
 end;
end;



procedure TFormMain.JvFileListBox1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
 if Source is TJvDirectoryListBox then
  Application.MessageBox(PAnsiChar((Source as TJvDirectoryListBox).Directory), 'Source')
 else if Source is TJvFileListBox then
  Application.MessageBox(PAnsiChar((Source as TJvFileListBox).FileName), 'Source')
end;



procedure TFormMain.JvFileListBox1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
 Accept:=true;
end;

procedure TFormMain.JvFileListBox2DblClick(Sender: TObject);
 var filename: string;
begin
// Un-comment next line to see the selected filename.
// Application.MessageBox(PAnsiChar(filename), 'Filename');

 // Remove space after directory name.
 filename:=RemoveSpace(JvFileListBox2.FileName);

// Un-comment next line to see the selected filename.
// Application.MessageBox(PAnsiChar(filename), 'Filename');

 if DirectoryExists(filename) then
 begin
  JvDirectoryListBox2.Directory:=filename;
  JvFileListBox2.Update;
  JvDirectoryListBox2.Update;
 end;
end;

procedure TFormMain.JvFileListBox2DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
 if Source is TJvDirectoryListBox then
  Application.MessageBox(PAnsiChar((Source as TJvDirectoryListBox).Directory), 'Source')
 else if Source is TJvFileListBox then
  Application.MessageBox(PAnsiChar((Source as TJvFileListBox).FileName), 'Source')
end;

procedure TFormMain.JvFileListBox2DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
 Accept:=true;
end;

end.
